/******************************************************************************
;  *   	@MCU				 : MC51F003A4
;  *   	@Create Date         : 2020.01.02
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			          ڳʼ                            		
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @Function Name       : UART1_Init
;  *    @Description         : 1ʼ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_Init(void)
{
	PCON |= DEF_SET_BIT7; //ʹUART1
	SCON_1 &= 0x3f;
	SCON_1 |= 0x50; //ʽ1  

	TMOD &= 0xCF;
	TMOD |= DEF_SET_BIT5; //ڲʱ  ʽ2
	TL1 = T1_Cnt;
	TH1 = T1_Cnt;
	TR1 = 1; //T1

	IE1 |= DEF_SET_BIT3; //UART1ж
}
/************************************************
;  *    @Function Name       : putchar   (ռ1kROM)
;  *    @Description         : printfضputchar
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
char putchar(char tx_data)
{
	SBUF_1 = tx_data; //дݵUARTݼĴ
	while (!(SCON_1 & 0x02)); //ȴǰݷ
	SCON_1 &= ~DEF_SET_BIT1;
	return tx_data;
}

uint8_t code TX_DATA_BUFF[10]={0XFF,0x53,0x49,0x4E,0x4F,0x4D,0x43,0x55,0xAA};		//¼

void UART1_ISR(void) interrupt UART1_IRQn
{
	static uint8_t	UART_rx_len=0;
	if (((SCON_1 & DEF_SET_BIT0) == DEF_SET_BIT0))
	{
		SCON_1 &= ~DEF_SET_BIT0;
		UART_rx_buff[UART_rx_len]=SBUF_1;
		//ڽ¼Э
		if(UART_RX_STA==0)
		{
			if(SBUF_1==0xFF)
			{
				if(UART_rx_len==0)
				{
					if(UART_rx_buff[UART_rx_len]==TX_DATA_BUFF[UART_rx_len])
					{
						UART_RX_STA=1;
						UART_rx_len++;
					}
				}
				else
				{
					UART_rx_len=0;
				}
			}
		}else
		{
			
			if(UART_rx_buff[UART_rx_len]==TX_DATA_BUFF[UART_rx_len])
			{
				UART_rx_len++;
				if(UART_rx_len>8)
				{
					NOP1();
					SWRST = 1;
					SWRST = 1;			//λ
				}
			}else
			{
				UART_rx_len=0;
				UART_RX_STA=0;
			}		
		}
	}
}

/**************************** end of file *********************************************/
